您的位置:首页 > 其它

POJ ---3126 Prime Path

2014-03-21 12:26 239 查看
Prime Path

Time Limit: 1000MSMemory Limit: 65536K
Total Submissions: 10370Accepted: 5922
Description


The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033
1733
3733
3739
3779
8779
8179


The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

思路:BFS,最先找到的必定是最小解。



#include<iostream>
#include<cstdio>
#include<cstring>
#include<cstdlib>
#include<queue>
#include<cmath>
#define MAX 11111
using namespace std;
int isprime[MAX], pre[MAX];
queue<int>q;
void Chose_Prime(){
isprime[0] = isprime[1] = 0;
for(int i = 2;i < MAX;i ++){
if(!isprime[i]){
for(int j = i + i;j < MAX;j += i)
isprime[j] = 1;
}
}
}
int Switch(int num, int i, int j){
int target = num/(int)pow(10., 3-i);
int temp = target%10;
return num += (j - temp)*(int)pow(10., 3-i);
}
int bfs(int st, int end){
int rr;
while(!q.empty()) q.pop();
q.push(st);
pre[st] = 0;
while(!q.empty()){
int p = q.front();
q.pop();
for(int i = 0;i < 4;i ++){
for(int j = 0;j <= 9;j ++){
if(i + j){
rr = Switch(p, i, j);
if(!isprime[rr] && pre[rr] == -1){
pre[rr] = p;
q.push(rr);
if(rr == end) return true;
}
}
}
}
}
return false;
}
int main(){
int T, a, b, ans;
Chose_Prime();
//freopen("in.c", "r", stdin);
cin >> T;
while(T--){
memset(pre, -1, sizeof(pre));
ans = 0;
cin >> a >> b;
if(a == b){
cout << 0 << endl;
continue;
}
if(bfs(a, b)){
while(pre[b] != 0){
ans ++;
b = pre[b];
}
cout << ans << endl;
}else{
cout << "impossible" << endl;
}
}
return 0;
}



                                            
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: